const calc = require("shunting-yard-arbitrary-precision");

+calc('3+2');;

+calc('3 +2  ');;
+calc('(10+5)/5');;
+calc('2 * (2 * (5 - 3))');;
+calc('4(6)');;
+calc('3+(5*2)*(-3+2)');;
+calc('2^3');;

var decimalFactory = require('arbitrary-precision');
var Decimal = decimalFactory(require('bigjs-adapter'));

+calc('0.1+0.2', {Decimal: Decimal});;

+calc('0.1+0.2');;

calc('1/3').toString();;

Decimal.setPrecision(50);
calc('1/3', {Decimal: Decimal}).toString();;

var context = new calc.Context();

context.def('abs');

+calc('2*abs(-3)', {context: context});;

context.def('tau', 2 * Math.PI);

+calc('3*tau', {context: context});;

context.def('javier', a => a * 1.618);

+calc('javier(21)', {context: context});;

const curryN = require('ramda/src/curryN');
const __ = require('ramda/src/__.js');
const curriedCalc = curryN(2, calc);
const myCalc = curriedCalc(__, {Decimal: Decimal, context: context});

+myCalc('javier(abs(-3))*.2');;
+calc('(1.618*3)*.2');;